{ config, lib, pkgs, ... }:

let 
  cfg = config.ptw.programs.obs;
in {
  options.ptw.programs.obs = {
    enable = lib.mkEnableOption "Configure OBS Studio";
  };

  config = lib.mkIf cfg.enable {
    home-manager.users.${config.ptw.system.singleUser}.programs.obs-studio = {
      enable = true;
      plugins = with pkgs.obs-studio-plugins; [
        wlrobs obs-vkcapture
      ];
    };
  };
}
